#include <bits/stdc++.h>

using namespace std;

const long long inf = (1LL << 62);
const int maxn = 100005;

int n;
long long base;
int period, d;

long long a[maxn];
long long dp[maxn];

struct SegmentTree
{
    long long tree[4 * maxn];

    void init()
    {
        fill(tree, tree + 4 * maxn, inf);
    }

    void update(int node, int l, int r, int pos, long long val)
    {
        if (l == r)
        {
            tree[node] = min(tree[node], val);
            return;
        }

        int mid = (l + r) / 2;

        if (pos <= mid)
        {
            update(2 * node, l, mid, pos, val);
        }
        else
        {
            update(2 * node + 1, mid + 1, r, pos, val);
        }

        tree[node] = min(tree[2 * node], tree[2 * node + 1]);
    }

    long long query(int node, int l, int r, int ql, int qr)
    {
        if (l > qr || r < ql)
        {
            return inf;
        }

        if (ql <= l && r <= qr)
        {
            return tree[node];
        }

        int mid = (l + r) / 2;

        return min(query(2 * node, l, mid, ql, qr), query(2 * node + 1, mid + 1, r, ql, qr));
    }
};

SegmentTree tree;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> base >> period >> d >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    if (d == 0)
    {
        cout << base << endl;
        return 0;
    }

    dp[0] = 0;
    a[0] = 0;
    tree.init();
    tree.update(1, 1, period, 0 + 1, 0);

    for (int i = 1; i <= n; ++i)
    {
        long long pref = (a[i] / period) * d + (a[i] / period) * period;
        //cout << "now " << tree.query(1, 1, period, 0 + 1, (a[i] % period - 1) + 1) + period + d << " :: " << tree.query(1, 1, period, a[i] % period + 1, period) << endl;
        dp[i] = pref - d + min(tree.query(1, 1, period, 0 + 1, (a[i] % period - 1) + 1) + period + d, tree.query(1, 1, period, a[i] % period + 1, period));
        tree.update(1, 1, period, a[i] % period + 1, dp[i] - pref);
        //cout << i << " :: " << dp[i] << " " << pref << endl;
    }

    long long ans = inf;

    for (int i = 0; i <= n; ++i)
    {
        long long dist = base - a[i];
        //cout << "here " << dist << " " << period << endl;
        long long radiation = (dist / period - (dist % period == 0)) * d;
        ans = min(ans, dp[i] + dist + radiation);
    }

    cout << ans << endl;

    return 0;
}
