#include <bits/stdc++.h>

using namespace std;

const int maxn = 1000005;
const long long BASE1 = 137;
const long long mod1 = 998244353;

int n, m, p;
char s[maxn];
char t[maxn];

long long pref1[maxn];
long long power1[maxn];

long long tpref1[maxn];

long long calcHash1(int from, int to)
{
    return (pref1[to] + mod1 * mod1 - pref1[from - 1] * power1[to - from + 1]) % mod1;
}

long long tCalcHash1(int from, int to)
{
    return (tpref1[to] + mod1 * mod1 - tpref1[from - 1] * power1[to - from + 1]) % mod1;
}

int calcLeft(int to)
{
    int l = 1;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (calcHash1(mid, to) == tpref1[to - mid + 1])
        {
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    return l;
}

int calcRight(int from)
{
    int l = from;
    int r = n;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (calcHash1(from, mid) == tCalcHash1(p - (mid - from + 1) + 1, p))
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return r;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> p;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        cin >> t[i];
    }

    reverse(t + 1, t + m + 1);

    ++p;

    if (p > m || p > n)
    {
        cout << "Zu" << endl;
        return 0;
    }

    power1[0] = 1;

    for (int i = 1; i <= n; ++i)
    {
        power1[i] = (power1[i - 1] * BASE1) % mod1;
        pref1[i] = (pref1[i - 1] * BASE1 + s[i]) % mod1;
    }

    long long target1 = 0;

    for (int i = 1; i <= p; ++i)
    {
        target1 = (target1 * BASE1 + t[i]) % mod1;
        tpref1[i] = target1;
    }

    for (int i = 1; i <= n - p + 1; ++i)
    {
        int to = i + p - 1;
        long long curr1 = (pref1[to] + mod1 * mod1 - pref1[i - 1] * power1[p]) % mod1;

        if (curr1 == target1)
        {
            cout << "K" << endl;
            cout << -1 << endl;
            return 0;
        }
    }

    /*for (int i = 1; i <= n; ++i)
    {
        //remove i
        int l = calcLeft(i - 1);
        int r = calcRight(i + 1);
        int lenL = i - l;
        int lenR = r - i;

        if (lenL + lenR >= p)
        {
            cout << "K" << endl;
            cout << i - 1 << endl;
            return 0;
        }
    }*/

    cout << "Zu" << endl;

    return 0;
}
