/**
 ____    ____    ____    __________________    ____    ____    ____
||I ||  ||c ||  ||e ||  ||                ||  ||M ||  ||a ||  ||n ||
||__||  ||__||  ||__||  ||________________||  ||__||  ||__||  ||__||
|/__\|  |/__\|  |/__\|  |/________________\|  |/__\|  |/__\|  |/__\|

*/

#include <iostream>
#include <chrono>
#include <vector>
#include <algorithm>
#include <cmath>

#define maxn 200005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;


using namespace std;


typedef long long ll;




ll findl(ll a, ll c)
{
    ll l = 1, r = a;
    ll ans = r + 1;

    while (l <= r)
    {
        ll mid = l + (r - l) / 2;
        if (floor((double)a / mid) > c)
            l = mid + 1;
        else
        {
            ans = mid;
            r = mid - 1;
        }
    }

    return ans;
}

ll findr(ll a, ll c)
{
    ll l = 1, r = a;
    ll ans = l - 1;

    while (l <= r)
    {
        ll mid = l + (r - l) / 2;
        if (floor((double)a / mid) < c)
            r = mid - 1;
        else
        {
            ans = mid;
            l = mid + 1;
        }
    }

    return ans;
}

ll calc(ll a, ll c)
{
    return findr(a, c) - findl(a, c) + 1;
}




ll dp[maxn];
ll n, m;
ll pref[maxn];

void read_solve()
{
    cin >> n >> m;
    dp[1] = 1;
    pref[1] = 1;

    for(ll i = 2   ; i <= n; i++)
    {
        dp[i] += pref[i - 1];

        for(ll j = 2; j <= sqrt(i); j++)
            if(i % j == 0)
            {
                //cout << "-> " << j << " ";
                dp[i] += (dp[i / j] * calc(i, i / j)) % m;
                dp[i] %= m;

                dp[i] += (dp[j] * calc(i, j)) % m;
                dp[i] %= m;
            }
        //cout << endl;

        //cout << ":: " << dp[i] << endl;
        //cout << "-> " << calc(i , 1) << endl;
        dp[i] += calc(i, 1) % m;
        dp[i] %= m;

        pref[i] = pref[i - 1] + dp[i];
        pref[i] %= m;
    }

    cout << dp[n] << endl;
}







int main()
{

    /**#ifdef ONLINE_JUDGE /// promeni
        freopen("taxi.in", "r", stdin);
        freopen("taxi.out", "w", stdout);
    #endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //startT = std::chrono::high_resolution_clock::now();

    //cout << calc(3 , 1) << endl;
    read_solve();

    return 0;
}
