#include <iostream>

using std::cin;
using std::cout;

#define endl '\n'
typedef int _int;
#define int long long


int dist;
int dmgP;
int dmg;
int hideoutCt;
int hideouts[100000];

int totalDmg = 0;

int calcRadDmg(int curPos, int destPos, int timeUntilDmg) {
    int dist = destPos - curPos;
    dist -= timeUntilDmg;
    if (dist <= 0) {
        return 0;
    }
    return dmg * (1 + (dist - 1) / dmgP);   
}
int calcRadDmgHideout(int curHideoutPos, int nextHideoutPos, int& timeUntilDmg) {
    int runTime = nextHideoutPos - curHideoutPos;
    int runDamage = calcRadDmg(curHideoutPos, nextHideoutPos, timeUntilDmg);    // radioactive
    int waitTime = timeUntilDmg + nextHideoutPos - curHideoutPos;
    int waitDamage = timeUntilDmg;                                              // environmental
    waitDamage += calcRadDmg(curHideoutPos, nextHideoutPos, dmgP);              // radioactive
    
    int time;
    int damage;
    if (runDamage <= waitDamage) {
        time = runTime;
        damage = runDamage;
    } else {
        time = waitTime;
        damage = waitDamage;
    }

    timeUntilDmg -= time;
    timeUntilDmg += time / dmgP * dmgP + dmgP;
    return damage;
}

#pragma optimize

_int main(_int argc, const char** argv) {
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin
        >> dist
        >> dmgP
        >> dmg
        >> hideoutCt
    ;
    for (int i = 0; i < hideoutCt; i++) {
        cin >> hideouts[i];
    }
    totalDmg = dist + calcRadDmg(0, hideouts[0], dmgP);
    int timeUntilDmg = hideouts[0] % dmgP;
    for (int i = 0; i < hideoutCt - 1; i++) {
        totalDmg += calcRadDmgHideout(hideouts[i], hideouts[i + 1], timeUntilDmg);
    }
    totalDmg += calcRadDmg(hideouts[hideoutCt - 1], dist, timeUntilDmg);

    cout << totalDmg << endl;

    return 0;
}